package cn.com.infosec.asn1.x9;

import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.util.Strings;
import java.util.Enumeration;
import java.util.Hashtable;

public class X962NamedCurves {
   static X9ECParametersHolder prime192v1 = new X962NamedCurves$1();
   static X9ECParametersHolder prime192v2 = new X962NamedCurves$2();
   static X9ECParametersHolder prime192v3 = new X962NamedCurves$3();
   static X9ECParametersHolder prime239v1 = new X962NamedCurves$4();
   static X9ECParametersHolder prime239v2 = new X962NamedCurves$5();
   static X9ECParametersHolder prime239v3 = new X962NamedCurves$6();
   static X9ECParametersHolder prime256v1 = new X962NamedCurves$7();
   static X9ECParametersHolder c2pnb163v1 = new X962NamedCurves$8();
   static X9ECParametersHolder c2pnb163v2 = new X962NamedCurves$9();
   static X9ECParametersHolder c2pnb163v3 = new X962NamedCurves$10();
   static X9ECParametersHolder c2pnb176w1 = new X962NamedCurves$11();
   static X9ECParametersHolder c2tnb191v1 = new X962NamedCurves$12();
   static X9ECParametersHolder c2tnb191v2 = new X962NamedCurves$13();
   static X9ECParametersHolder c2tnb191v3 = new X962NamedCurves$14();
   static X9ECParametersHolder c2pnb208w1 = new X962NamedCurves$15();
   static X9ECParametersHolder c2tnb239v1 = new X962NamedCurves$16();
   static X9ECParametersHolder c2tnb239v2 = new X962NamedCurves$17();
   static X9ECParametersHolder c2tnb239v3 = new X962NamedCurves$18();
   static X9ECParametersHolder c2pnb272w1 = new X962NamedCurves$19();
   static X9ECParametersHolder c2pnb304w1 = new X962NamedCurves$20();
   static X9ECParametersHolder c2tnb359v1 = new X962NamedCurves$21();
   static X9ECParametersHolder c2pnb368w1 = new X962NamedCurves$22();
   static X9ECParametersHolder c2tnb431r1 = new X962NamedCurves$23();
   static final Hashtable objIds = new Hashtable();
   static final Hashtable curves = new Hashtable();
   static final Hashtable names = new Hashtable();

   static {
      X9ECParametersHolder var0 = prime192v1;
      defineCurve("prime192v1", X9ObjectIdentifiers.prime192v1, var0);
      var0 = prime192v2;
      defineCurve("prime192v2", X9ObjectIdentifiers.prime192v2, var0);
      var0 = prime192v3;
      defineCurve("prime192v3", X9ObjectIdentifiers.prime192v3, var0);
      var0 = prime239v1;
      defineCurve("prime239v1", X9ObjectIdentifiers.prime239v1, var0);
      var0 = prime239v2;
      defineCurve("prime239v2", X9ObjectIdentifiers.prime239v2, var0);
      var0 = prime239v3;
      defineCurve("prime239v3", X9ObjectIdentifiers.prime239v3, var0);
      var0 = prime256v1;
      defineCurve("prime256v1", X9ObjectIdentifiers.prime256v1, var0);
      var0 = c2pnb163v1;
      defineCurve("c2pnb163v1", X9ObjectIdentifiers.c2pnb163v1, var0);
      var0 = c2pnb163v2;
      defineCurve("c2pnb163v2", X9ObjectIdentifiers.c2pnb163v2, var0);
      var0 = c2pnb163v3;
      defineCurve("c2pnb163v3", X9ObjectIdentifiers.c2pnb163v3, var0);
      var0 = c2pnb176w1;
      defineCurve("c2pnb176w1", X9ObjectIdentifiers.c2pnb176w1, var0);
      var0 = c2tnb191v1;
      defineCurve("c2tnb191v1", X9ObjectIdentifiers.c2tnb191v1, var0);
      var0 = c2tnb191v2;
      defineCurve("c2tnb191v2", X9ObjectIdentifiers.c2tnb191v2, var0);
      var0 = c2tnb191v3;
      defineCurve("c2tnb191v3", X9ObjectIdentifiers.c2tnb191v3, var0);
      var0 = c2pnb208w1;
      defineCurve("c2pnb208w1", X9ObjectIdentifiers.c2pnb208w1, var0);
      var0 = c2tnb239v1;
      defineCurve("c2tnb239v1", X9ObjectIdentifiers.c2tnb239v1, var0);
      var0 = c2tnb239v2;
      defineCurve("c2tnb239v2", X9ObjectIdentifiers.c2tnb239v2, var0);
      var0 = c2tnb239v3;
      defineCurve("c2tnb239v3", X9ObjectIdentifiers.c2tnb239v3, var0);
      var0 = c2pnb272w1;
      defineCurve("c2pnb272w1", X9ObjectIdentifiers.c2pnb272w1, var0);
      var0 = c2pnb304w1;
      defineCurve("c2pnb304w1", X9ObjectIdentifiers.c2pnb304w1, var0);
      var0 = c2tnb359v1;
      defineCurve("c2tnb359v1", X9ObjectIdentifiers.c2tnb359v1, var0);
      var0 = c2pnb368w1;
      defineCurve("c2pnb368w1", X9ObjectIdentifiers.c2pnb368w1, var0);
      var0 = c2tnb431r1;
      defineCurve("c2tnb431r1", X9ObjectIdentifiers.c2tnb431r1, var0);
   }

   static void defineCurve(String name, DERObjectIdentifier oid, X9ECParametersHolder holder) {
      objIds.put(name, oid);
      names.put(oid, name);
      curves.put(oid, holder);
   }

   public static X9ECParameters getByName(String name) {
      DERObjectIdentifier name1;
      return (name1 = (DERObjectIdentifier)objIds.get(Strings.toLowerCase(name))) != null ? getByOID(name1) : null;
   }

   public static X9ECParameters getByOID(DERObjectIdentifier oid) {
      X9ECParametersHolder oid1;
      return (oid1 = (X9ECParametersHolder)curves.get(oid)) != null ? oid1.getParameters() : null;
   }

   public static DERObjectIdentifier getOID(String name) {
      return (DERObjectIdentifier)objIds.get(Strings.toLowerCase(name));
   }

   public static String getName(DERObjectIdentifier oid) {
      return (String)names.get(oid);
   }

   public static Enumeration getNames() {
      return objIds.keys();
   }
}
